
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Python操作 Memcache、Redis、RabbitMQ、SQLAlchemy / 憋错料</title>

    <meta name="description" content="Python操作 Memcache、Redis、RabbitMQ、SQLAlchemy Memcached Memcached 是一个高性能的分布式内存对象缓存系统,用于动态Web应用以减轻数据库负载.它通过在内存中缓存数据和对象来减少读取数据库的次数,从而提高动态.数据库驱动网站的速度.Memcached基于一个存储键/值对的hashmap.其守护进程(daemon )是用C写的,但是客户端可以用任何语言来编写,并通过memcached协议与守护进程通信. 安装 yum -y install libevent-devel wget http://memcached.org/lat">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Python操作 Memcache、Redis、RabbitMQ、SQLAlchemy</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Memcached</p>
<p>Memcached 是一个高性能的分布式内存对象缓存系统，用于动态Web应用以减轻数据库负载。它通过在内存中缓存数据和对象来减少读取数据库的次数，从而提高动态、数据库驱动网站的速度。Memcached基于一个存储键/值对的<a href="http://baike.baidu.com/view/1487140.htm" rel="external nofollow noreferrer">hashmap</a>。其<a href="http://baike.baidu.com/view/53123.htm" rel="external nofollow noreferrer">守护进程</a>（daemon ）是用<a href="http://baike.baidu.com/subview/10075/6770152.htm" rel="external nofollow noreferrer">C</a>写的，但是客户端可以用任何语言来编写，并通过memcached协议与守护进程通信。</p>
<p>安装</p>
<p><strong>yum -y install libevent-devel</strong></p>
<p><strong>wget http://memcached.org/latest </strong></p>
<p><strong>tar -zxvf memcached-1.x.x.tar.gz </strong></p>
<p><strong>cd memcached-1.x.x</strong></p>
<p><strong> ./configure &amp;&amp; make &amp;&amp; make test &amp;&amp; sudo make install</strong></p>
<p><strong>&nbsp;</strong></p>
<p>启动Memcached</p>
<p><code>memcached&nbsp;</code><code>-</code><code>d&nbsp;</code><code>-</code><code>m&nbsp;</code><code>10</code>&nbsp;&nbsp;&nbsp;&nbsp;<code>-</code><code>u root&nbsp;</code><code>-</code><code>l&nbsp;</code><code>10.211</code><code>.</code><code>55.4</code>&nbsp;<code>-</code><code>p 12000</code>&nbsp;<code>-</code><code>c&nbsp;</code><code>256</code>&nbsp;<code>-</code><code>P&nbsp;</code><code>/</code><code>tmp</code><code>/</code><code>memcached.pid</code></p>

<p><code>参数说明:</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>-</code><code>d 是启动一个守护进程</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>-</code><code>m 是分配给Memcache使用的内存数量，单位是MB</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>-</code><code>u 是运行Memcache的用户</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>-</code><code>l 是监听的服务器IP地址</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>-</code><code>p 是设置Memcache监听的端口,最好是</code><code>1024</code><code>以上的端口</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>-</code><code>c 选项是最大运行的并发连接数，默认是</code><code>1024</code><code>，按照你服务器的负载量来设定</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>-</code><code>P 是设置保存Memcache的pid文件</code></p>


<p>命令：</p>

<p><code>存储命令:&nbsp;</code><code>set</code><code>/</code><code>add</code><code>/</code><code>replace</code><code>/</code><code>append</code><code>/</code><code>prepend</code><code>/</code><code>cas&nbsp;</code></p>
<p><code>获取命令: get</code><code>/</code><code>gets</code></p>
<p><code>其他命令: delete</code><code>/</code><code>stats..</code></p>


<p>Python操作Memcached</p>
<p><code>1、python操作Memcached使用Python</code><code>-</code><code>memcached模块</code></p>
<p><code>安装模块：https:</code><code>/</code><code>/</code><code>pypi.python.org</code><code>/</code><code>pypi</code><code>/</code><code>python</code><code>-</code><code>memcached</code></p>
<p>wget https://pypi.python.org/packages/f7/62/14b2448cfb04427366f24104c9da97cf8ea380d7258a3233f066a951a8d8/python-memcached-1.58.tar.gz</p>
<p>tar fx&nbsp;python-memcached-1.58.tar.gz</p>
<p>cd&nbsp;python-memcached-1.58</p>
<p>python3 setup.py install</p>

<p>先启动memcached</p>

<p>[[email&#160;protected] bin]# ps -ef|grep mem<br />root      7081     1  0 11:51 ?        00:00:00 memcached -d -m 10 -u root -l 10.211.55.5 -p 12000 -c 256 -P /tmp/memcached.pid<br />root      7123  4046  0 11:51 pts/1    00:00:00 grep mem</p>
<p><strong>1、第一次操作</strong></p>
<pre>1 import memcache
2
3 mc = memcache.Client([‘10.211.55.5:12000‘], debug=True)
4 mc.set("foo", "bar")
5 ret = mc.get(‘foo‘)
6 print (ret)
7  </pre>
<p><strong>2、天生支持集群</strong></p>
<p>python-memcached模块原生支持集群操作，其原理是在内存维护一个主机列表，且集群中主机的权重值和主机在列表中重复出现的次数成正比</p>
<p><code>&nbsp;&nbsp;　　</code><code>主机&nbsp;&nbsp;&nbsp; 权重</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>1.1</code><code>.</code><code>1.1</code>&nbsp;&nbsp;&nbsp;<code>1</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>1.1</code><code>.</code><code>1.2</code>&nbsp;&nbsp;&nbsp;<code>2</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>1.1</code><code>.</code><code>1.3</code>&nbsp;&nbsp;&nbsp;<code>1</code></p>

<p><code>那么在内存中主机列表为：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>host_list&nbsp;</code><code>=</code>&nbsp;<code>[</code><code>"1.1.1.1"</code><code>,&nbsp;</code><code>"1.1.1.2"</code><code>,&nbsp;</code><code>"1.1.1.2"</code><code>,&nbsp;</code><code>"1.1.1.3"</code><code>, ]</code></p>

<p>如果用户根据如果要在内存中创建一个键值对（如：k1 = "v1"），那么要执行一下步骤：</p>
<ul>
<li>根据算法将 k1 转换成一个数字</li>
<li>将数字和主机列表长度求余数，得到一个值 N（ 0 &lt;= N &lt; 列表长度 ）</li>
<li>在主机列表中根据 第2步得到的值为索引获取主机，例如：host_list[N]</li>
<li>连接 将第3步中获取的主机，将 k1 = "v1" 放置在该服务器的内存中</li>
</ul>
<p>代码实现如下：</p>
<p><code>mc&nbsp;</code><code>=</code>&nbsp;<code>memcache.Client([(</code><code>‘1.1.1.1:12000‘</code><code>,&nbsp;</code><code>1</code><code>), (</code><code>‘1.1.1.2:12000‘</code><code>,&nbsp;</code><code>2</code><code>), (</code><code>‘1.1.1.3:12000‘</code><code>,&nbsp;</code><code>1</code><code>)], debug</code><code>=</code><code>True</code><code>)</code></p>
<p><code>mc.</code><code>set</code><code>(</code><code>‘k1‘</code><code>,&nbsp;</code><code>‘v1‘</code><code>)</code></p>
<p>3、操作</p>
<pre> 1 &gt;&gt;&gt; import memcache  #导入模块
 2
 3 &gt;&gt;&gt; mc = memcache.Client([‘10.211.55.5:12000‘],debug=True) #连接
 4 &gt;&gt;&gt; mc.set(‘x‘,1)    #set()设置参数
 5 True
 6 &gt;&gt;&gt; mc.set(‘y‘,2)
 7 True
 8 &gt;&gt;&gt; mc.set(‘z‘,3)
 9 True
10 &gt;&gt;&gt; print (mc.get(‘x‘))   #get()获取参数
11 1
12 &gt;&gt;&gt; print (mc.get(‘y‘))
13 2
14 &gt;&gt;&gt; print (mc.get(‘x‘))
15 1
16 &gt;&gt;&gt; print (mc.get(‘z‘))
17 3
18 &gt;&gt;&gt; mc.add(‘a‘,11)  #增加参数，如已存在，刚报错
19 True
20 &gt;&gt;&gt; mc.add(‘a‘,11)
21 False
22 MemCached: while expecting ‘STORED‘, got unexpected response ‘NOT_STORED‘
23 &gt;&gt;&gt; mc.add(‘x‘,11)
24 MemCached: while expecting ‘STORED‘, got unexpected response ‘NOT_STORED‘
25 False
26
27 &gt;&gt;&gt; mc.get_multi([‘x‘,‘y‘,‘z‘])   #获取多个值，反回字典形式
28 {‘z‘: 3, ‘x‘: 1, ‘y‘: 2}
29 &gt;&gt;&gt; mc.delete(‘a‘)
30 1
31 &gt;&gt;&gt; mc.set_multi({‘a‘:11,‘b‘:22,‘c‘:33}) == []  #设置多个数值，返回空列表
32 True
33 &gt;&gt;&gt; mc.get(‘a‘)
34 11
35 &gt;&gt;&gt; mc.get(‘b‘)
36 22
37 &gt;&gt;&gt; mc.get(‘c‘)
38 33
39 &gt;&gt;&gt; mc.delete(‘a‘)   #删除
40 1
41 &gt;&gt;&gt; mc.get(‘a‘)
42 &gt;&gt;&gt; mc.get(‘b‘)
43 22
44 &gt;&gt;&gt; mc.cas(‘b‘,‘2222‘)    #对已存在的值修改
45 True
46 &gt;&gt;&gt; mc.get(‘b‘)
47 ‘2222‘
48
49 &gt;&gt;&gt; mc.set(‘name‘,‘haha‘,10) #设置失效时间（10为失效时间为10s）
50 True
51 &gt;&gt;&gt; mc.get(‘name‘)
52 ‘haha‘
53 &gt;&gt;&gt; mc.get(‘name‘)     #10秒后找不到了
54
55 &gt;&gt;&gt; mc.replace(‘b‘,1111)    #修改，值不存在则添加
56 True
57 &gt;&gt;&gt; mc.get(‘b‘)
58 1111
59
60 &gt;&gt;&gt; mc.set(‘haha‘,‘‘)  #设置值为空
61 True
62 &gt;&gt;&gt; mc.replace(‘haha‘,‘nimeide‘)
63 True
64 &gt;&gt;&gt; mc.get(‘haha‘)
65 ‘nimeide‘
66
67 &gt;&gt;&gt; mc.get(‘x‘)   #整数加法，默认是1
68 1
69 &gt;&gt;&gt; mc.incr(‘x‘)
70 2
71 &gt;&gt;&gt; mc.incr(‘x‘)
72 3
73 &gt;&gt;&gt; mc.incr(‘x‘,11)
74 14
75 &gt;&gt;&gt; mc.get(‘x‘)   #整数减法，默认是1
76 14
77 &gt;&gt;&gt; mc.decr(‘x‘)
78 13
79 &gt;&gt;&gt; mc.decr(‘x‘)
80 12
81 &gt;&gt;&gt; mc.decr(‘x‘,10)
82 2</pre>
<p><strong>4、gets 和&nbsp;cas</strong></p>
<p>如商城商品剩余个数，假设改值保存在memcache中，product_count = 900<br />A用户刷新页面从memcache中读取到product_count = 900<br />B用户刷新页面从memcache中读取到product_count = 900</p>
<p>如果A、B用户均购买商品</p>
<p>A用户修改商品剩余个数 product_count＝899<br />B用户修改商品剩余个数 product_count＝899</p>
<p>如此一来缓存内的数据便不在正确，两个用户购买商品后，商品剩余还是 899<br />如果使用python的set和get来操作以上过程，那么程序就会如上述所示情况！</p>
<p>如果想要避免此情况的发生，只要使用 gets 和 cas 即可，如：</p>
<p>Ps：本质上每次执行gets时，会从memcache中获取一个自增的数字，通过cas去修改gets的值时，会携带之前获取的自增值和memcache中的自增值进行比较，如果相等，则可以提交，如果不想等，那表示在gets和cas执行之间，又有其他人执行了gets（获取了缓冲的指定值）， 如此一来有可能出现非正常数据，则不允许修改。</p>
<h1>redis</h1>
<p>redis是一个key-value<a href="http://baike.baidu.com/view/51839.htm" rel="external nofollow noreferrer">存储系统</a>。和Memcached类似，它支持存储的value类型相对更多，包括string(字符串)、list(<a href="http://baike.baidu.com/view/549479.htm" rel="external nofollow noreferrer">链表</a>)、set(集合)、zset(sorted set --有序集合)和hash（哈希类型）。这些<a href="http://baike.baidu.com/view/675645.htm" rel="external nofollow noreferrer">数据类型</a>都支持push/pop、add/remove及取交集并集和差集及更丰富的操作，而且这些操作都是原子性的。在此基础上，redis支持各种不同方式的排序。与memcached一样，为了保证效率，数据都是缓存在内存中。区别的是redis会周期性的把更新的数据写入磁盘或者把修改操作写入追加的记录文件，并且在此基础上实现了master-slave(主从)同步。</p>
<p>安装：</p>
<p><code>wget http:</code><code>/</code><code>/</code><code>download.redis.io</code><code>/</code><code>releases</code><code>/</code><code>redis</code><code>-</code><code>3.0</code><code>.</code><code>6.tar</code><code>.gz</code></p>
<p><code>tar xzf redis</code><code>-</code><code>3.0</code><code>.</code><code>6.tar</code><code>.gz</code></p>
<p><code>cd redis</code><code>-</code><code>3.0</code><code>.</code><code>6</code></p>
<p><code>make install</code></p>


<p>启动服务端</p>

<p>#./src/redis-server &amp;</p>

<p>启动客户端</p>

<p># ./src/redis-cli <br />127.0.0.1:6379&gt;</p>
<p>127.0.0.1:6379&gt; set foo bar<br />OK<br />127.0.0.1:6379&gt; get foo<br />"bar"<br />127.0.0.1:6379&gt;</p>
<p>二、Python操作Redis</p>
<p>sudo pip3 install redis</p>
<p>or</p>
<p>sudo easy_install redis</p>
<p>or</p>
<p>源码安装</p>
<p><code>详见：https:</code><code>/</code><code>/</code><code>github.com</code><code>/</code><code>WoLpH</code><code>/</code><code>redis</code><code>-</code><code>py</code></p>
<p>API使用</p>
<p>redis-py 的API的使用可以分类为：</p>
<ul>
<li>连接方式</li>
<li>连接池</li>
<li>操作
<ul>
<li>String 操作</li>
<li>Hash 操作</li>
<li>List 操作</li>
<li>Set 操作</li>
<li>Sort Set 操作</li>
</ul>
</li>
<li>管道</li>
<li>发布订阅</li>
</ul>

<p>1、操作模式</p>

<p>redis-py提供两个类Redis和StrictRedis用于实现Redis的命令，StrictRedis用于实现大部分官方的命令，并使用官方的语法和命令，Redis是StrictRedis的子类，用于向后兼容旧版本的redis-py。</p>
<pre>import redis

r = redis.Redis(host=‘10.211.55.5‘,port=6379,)

r.set(‘haha‘,‘soso‘)

print(r.get(‘haha‘))
</pre>
<p>结果如下</p>
<pre>b‘soso‘
</pre>
<p>2、连接池</p>
<p>redis-py使用connection pool来管理对一个redis server的所有连接，避免每次建立、释放连接的开销。默认，每个Redis实例都会维护一个自己的连接池。可以直接建立一个连接池，然后作为参数Redis，这样就可以实现多个Redis实例共享一个连接池。</p>
<pre>import redis

pool = redis.ConnectionPool(host=‘10.211.55.5‘,port=6379,)

r = redis.Redis(connection_pool=pool)

r.set(‘haha‘,‘hehe‘)
print(r.get(‘haha‘))
</pre>
<p>结果哪下</p>
<pre>b‘hehe‘
</pre>
<p>3、操作</p>
<p>String操作，redis中的String在在内存中按照一个name对应一个value来存储。如图：</p>
<p>name　　　　　　value</p>
<p>n1 &nbsp; ======&gt; &nbsp; &nbsp; v1</p>
<p>n2 &nbsp; ======&gt; &nbsp; &nbsp; v2</p>
<p>n3 &nbsp; ======&gt; &nbsp; &nbsp; v3</p>
<p>set(name, value, ex=None, px=None, nx=False, xx=False)</p>
<p>在Redis中设置值，默认，不存在则创建，存在则修改</p>
<p><code>参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ex，过期时间（秒）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>px，过期时间（毫秒）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>nx，如果设置为True，则只有name不存在时，当前set操作才执行</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>xx，如果设置为True，则只有name存在时，岗前set操作才执行</code></p>

<p>setnx(name, value)</p>
<p>设置值，只有name不存在时，执行设置操作（添加）</p>

<p>setex(name, value, time)</p>
<p><code># 设置值</code></p>
<p><code># 参数：</code></p>
<p><code></code><code># time，过期时间（数字秒 或 timedelta对象）</code></p>

<p>psetex(name, time_ms, value)</p>
<p><code># 设置值</code></p>
<p><code># 参数：</code></p>
<p><code></code><code># time_ms，过期时间（数字毫秒 或 timedelta对象）</code></p>

<p>mset(*args, **kwargs)</p>
<p><code>批量设置值</code></p>
<p><code>如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>mset(k1=</code><code>‘v1‘</code><code>, k2=</code><code>‘v2‘</code><code>)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>或</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>mget({</code><code>‘k1‘</code><code>:&nbsp;</code><code>‘v1‘</code><code>,&nbsp;</code><code>‘k2‘</code><code>:&nbsp;</code><code>‘v2‘</code><code>})</code></p>

<p>get(name)</p>
<p>获取值</p>

<p>mget(keys, *args)</p>
<p><code>批量获取</code></p>
<p><code>如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>mget(</code><code>‘ylr‘</code><code>,&nbsp;</code><code>‘haha‘</code><code>)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>或</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>r.mget([</code><code>‘ylr‘</code><code>,&nbsp;</code><code>‘haha‘</code><code>])</code></p>

<p>getset(name, value)</p>
<p>设置新值并获取原来的值</p>

<p>getrange(key, start, end)</p>
<p><code># 获取子序列（根据字节获取，非字符）</code></p>
<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，Redis 的 name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># start，起始位置（字节）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># end，结束位置（字节）</code></p>
<p><code># 如： "孙悟空" ，0-3表示 "孙"</code></p>


<p>setrange(name, offset, value)</p>
<p><code># 修改字符串内容，从指定字符串索引开始向后替换（新值太长时，则向后添加）</code></p>
<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># offset，字符串的索引，字节（一个汉字三个字节）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># value，要设置的值</code></p>

<p>incr(self, name, amount=1)</p>
<p><code># 自增 name对应的值，当name不存在时，则创建name＝amount，否则，则自增。</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name,Redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># amount,自增数（必须是整数）</code></p>

<p><code># 注：同incrby</code></p>


<p>incrbyfloat(self, name, amount=1.0)</p>
<p><code># 自增 name对应的值，当name不存在时，则创建name＝amount，否则，则自增。</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name,Redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># amount,自增数（浮点型）</code></p>

<p>decr(self, name, amount=1)</p>
<p><code># 自减 name对应的值，当name不存在时，则创建name＝amount，否则，则自减。</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name,Redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># amount,自减数（整数）</code></p>

<p>append(key, value)</p>
<p><code># 在redis name对应的值后面追加内容</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>key, redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>value, 要追加的字符串</code></p>


<p>Hash操作，redis中Hash在内存中的存储格式如下图：</p>

<p>name　　　　　　　　hash</p>
<p>n1 &nbsp;=========&gt; k1-&gt;v1</p>
<p>　　　　　　　　　　　&nbsp;k2-&gt;v2</p>
<p>　　　　　　　　　　　&nbsp;k3-&gt;v3</p>


<p>　n2 =========&gt; k9-&gt;v9</p>
<p>　　　　　　　　　　　kn-&gt;vn</p>


<p>hset(name, key, value)</p>
<p><code># name对应的hash中设置一个键值对（不存在，则创建；否则，修改）</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># key，name对应的hash中的key</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># value，name对应的hash中的value</code></p>

<p><code># 注：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># hsetnx(name, key, value),当name对应的hash中不存在当前key时则创建（相当于添加）</code></p>

<p>hmset(name, mapping)</p>

<p><code># 在name对应的hash中批量设置键值对</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># mapping，字典，如：{‘k1‘:‘v1‘, ‘k2‘: ‘v2‘}</code></p>

<p><code># 如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># r.hmset(‘xx‘, {‘k1‘:‘v1‘, ‘k2‘: ‘v2‘})</code></p>


<p>hget(name,key)</p>
<p># 在name对应的hash中获取根据key获取value</p>


<p>hmget(name, keys, *args)</p>

<p><code># 在name对应的hash中获取多个key的值</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，reids对应的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># keys，要获取key集合，如：[‘k1‘, ‘k2‘, ‘k3‘]</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># *args，要获取的key，如：k1,k2,k3</code></p>

<p><code># 如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># r.mget(‘xx‘, [‘k1‘, ‘k2‘])</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 或</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># print r.hmget(‘xx‘, ‘k1‘, ‘k2‘)</code></p>

<p>hgetall(name)</p>
<p><code>获取name对应</code><code>hash</code><code>的所有键值</code></p>


<p>hlen(name)</p>
<p># 获取name对应的hash中键值对的个数</p>


<p>hkeys(name)</p>
<p># 获取name对应的hash中所有的key的值</p>

<p>hvals(name)</p>
<p># 获取name对应的hash中所有的value的值</p>


<p>hexists(name, key)</p>
<p># 检查name对应的hash是否存在当前传入的key</p>


<p>hdel(name,*keys)</p>
<p># 将name对应的hash中指定key的键值对删除</p>


<p>hincrby(name, key, amount=1)</p>
<p><code># 自增name对应的hash中的指定key的值，不存在则创建key=amount</code></p>
<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis中的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># key， hash对应的key</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># amount，自增数（整数）</code></p>


<p>hincrbyfloat(name, key, amount=1.0)</p>

<p><code># 自增name对应的hash中的指定key的值，不存在则创建key=amount</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis中的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># key， hash对应的key</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># amount，自增数（浮点数）</code></p>

<p><code># 自增name对应的hash中的指定key的值，不存在则创建key=amount</code></p>


<p>hscan(name, cursor=0, match=None, count=None)</p>

<p><code># 增量式迭代获取，对于数据大的数据非常有用，hscan可以实现分片的获取数据，并非一次性将数据全部获取完，从而放置内存被撑爆</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># cursor，游标（基于游标分批取获取数据）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># match，匹配指定key，默认None 表示所有的key</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># count，每次分片最少获取个数，默认None表示采用Redis的默认分片个数</code></p>

<p><code># 如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 第一次：cursor1, data1 = r.hscan(‘xx‘, cursor=0, match=None, count=None)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 第二次：cursor2, data1 = r.hscan(‘xx‘, cursor=cursor1, match=None, count=None)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># ...</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 直到返回值cursor的值为0时，表示数据已经通过分片获取完毕</code></p>



<p>hscan_iter(name, match=None, count=None)</p>

<p><code>&nbsp;利用yield封装hscan创建生成器，实现分批去redis中获取数据</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># match，匹配指定key，默认None 表示所有的key</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># count，每次分片最少获取个数，默认None表示采用Redis的默认分片个数</code></p>

<p><code># 如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># for item in r.hscan_iter(‘xx‘):</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>#&nbsp;&nbsp;&nbsp;&nbsp; print item</code></p>


<p>List操作，redis中的List在在内存中按照一个name对应一个List来存储。如图：</p>

<p>name　　　　　　　　list</p>
<p>n1 ========&gt; [v1,v2,v3...]</p>
<p>n2 ========&gt; [n1,n2,n3...]</p>


<p>lpush(name,values)</p>
<p><code># 在name对应的list中添加元素，每个新的元素都添加到列表的最左边</code></p>

<p><code># 如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># r.lpush(‘oo‘, 11,22,33)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 保存顺序为: 33,22,11</code></p>

<p><code># 扩展：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># rpush(name, values) 表示从右向左操作</code></p>


<p>lpushx(name,value)</p>
<p><code># 在name对应的list中添加元素，只有name已经存在时，值添加到列表的最左边</code></p>

<p><code># 更多：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># rpushx(name, value) 表示从右向左操作</code></p>


<p>llen(name)</p>
<p># name对应的list元素的个数</p>


<p>linsert(name, where, refvalue, value))</p>
<p><code># 在name对应的列表的某一个值前或后插入一个新值</code></p>
<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># where，BEFORE或AFTER</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># refvalue，标杆值，即：在它前后插入数据</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># value，要插入的数据</code></p>


<p>r.lset(name, index, value)</p>
<p><code># 对name对应的list中的某一个索引位置重新赋值</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># index，list的索引位置</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># value，要设置的值</code></p>


<p>r.lrem(name, value, num)</p>
<p><code># 在name对应的list中删除指定的值</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># value，要删除的值</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># num，&nbsp; num=0，删除列表中所有的指定值；</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code># num=2,从前到后，删除2个；</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code># num=-2,从后向前，删除2个</code></p>


<p>lpop(name)</p>
<p><code># 在name对应的列表的左侧获取第一个元素并在列表中移除，返回值则是第一个元素</code></p>

<p><code># 更多：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># rpop(name) 表示从右向左操作</code></p>


<p>lindex(name, index)</p>
<p>#在name对应的列表中根据索引获取列表元素</p>


<p>lrange(name, start, end)</p>
<p><code># 在name对应的列表分片获取数据</code></p>
<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># start，索引的起始位置</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># end，索引结束位置</code></p>

<p>ltrim(name, start, end)</p>
<p><code># 在name对应的列表中移除没有在start-end索引之间的值</code></p>
<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># start，索引的起始位置</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># end，索引结束位置</code></p>

<p>rpoplpush(src, dst)</p>
<p><strong><strong><code># 从一个列表取出最右边的元素，同时将其添加至另一个列表的最左边</code></strong></strong></p>
<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># src，要取数据的列表的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># dst，要添加数据的列表的name</code></p>


<p>blpop(keys, timeout)</p>
<p><code># 将多个列表排列，按照从左到右去pop对应列表的元素</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># keys，redis的name的集合</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># timeout，超时时间，当元素所有列表的元素获取完之后，阻塞等待列表内有数据的时间（秒）, 0 表示永远阻塞</code></p>

<p><code># 更多：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># r.brpop(keys, timeout)，从右向左获取数据</code></p>

<p>brpoplpush(src, dst, timeout=0)</p>
<p><code># 从一个列表的右侧移除一个元素并将其添加到另一个列表的左侧</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># src，取出并要移除元素的列表对应的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># dst，要插入元素的列表对应的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># timeout，当src对应的列表中没有数据时，阻塞等待其有数据的超时时间（秒），0 表示永远阻塞</code></p>

<p>自定义增量迭代</p>
<p><code># 由于redis类库中没有提供对列表元素的增量迭代，如果想要循环name对应的列表的所有元素，那么就需要：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 1、获取name对应的所有列表</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 2、循环列表</code></p>
<p><code># 但是，如果列表非常大，那么就有可能在第一步时就将程序的内容撑爆，所有有必要自定义一个增量迭代的功能：</code></p>

<p><code>def</code>&nbsp;<code>list_iter(name):</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>"""</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>自定义redis列表增量迭代</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>:param name: redis中的name，即：迭代name对应的列表</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>:return: yield 返回 列表元素</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>"""</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>list_count&nbsp;</code><code>=</code>&nbsp;<code>r.llen(name)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>for</code>&nbsp;<code>index&nbsp;</code><code>in</code>&nbsp;<code>xrange</code><code>(list_count):</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>yield</code>&nbsp;<code>r.lindex(name, index)</code></p>

<p><code># 使用</code></p>
<p><code>for</code>&nbsp;<code>item&nbsp;</code><code>in</code>&nbsp;<code>list_iter(</code><code>‘pp‘</code><code>):</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>print</code>&nbsp;<code>item</code></p>


<p><strong>Set操作，Set集合就是不允许重复的列表</strong></p>


<p>sadd(name,values)</p>
<p># name对应的集合中添加元素</p>
<p>scard(name)</p>
<p>获取name对应的集合中元素个数</p>
<p>sdiff(keys, *args)</p>
<p>在第一个name对应的集合中且不在其他name对应的集合的元素集合</p>
<p>sdiffstore(dest, keys, *args)</p>
<p># 获取第一个name对应的集合中且不在其他name对应的集合，再将其新加入到dest对应的集合中</p>
<p>sinter(keys, *args)</p>
<p># 获取多一个name对应集合的并集</p>
<p>sinterstore(dest, keys, *args)</p>
<p># 获取多一个name对应集合的并集，再讲其加入到dest对应的集合中</p>
<p>sismember(name, value)</p>
<p># 检查value是否是name对应的集合的成员</p>
<p>smembers(name)</p>
<p># 获取name对应的集合的所有成员</p>
<p>smove(src, dst, value)</p>
<p># 将某个成员从一个集合中移动到另外一个集合</p>
<p>spop(name)</p>
<p># 从集合的右侧（尾部）移除一个成员，并将其返回</p>
<p>srandmember(name, numbers)</p>
<p># 从name对应的集合中随机获取 numbers 个元素</p>
<p>srem(name, values)</p>
<p># 在name对应的集合中删除某些值</p>
<p>sunion(keys, *args)</p>
<p># 获取多一个name对应的集合的并集</p>
<p>sunionstore(dest,keys, *args)</p>
<p># 获取多一个name对应的集合的并集，并将结果保存到dest对应的集合中</p>
<p>sscan(name, cursor=0, match=None, count=None)<br />sscan_iter(name, match=None, count=None)</p>
<p># 同字符串的操作，用于增量迭代分批获取元素，避免内存消耗太大</p>
<p>有序集合，在集合的基础上，为每元素排序；元素的排序需要根据另外一个值来进行比较，所以，对于有序集合，每一个元素有两个值，即：值和分数，分数专门用来做排序。</p>
<p>zadd(name, *args, **kwargs)</p>
<p><code># 在name对应的有序集合中添加元素</code></p>
<p><code># 如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code># zadd(‘zz‘, ‘n1‘, 1, ‘n2‘, 2)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 或</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code># zadd(‘zz‘, n1=11, n2=22)</code></p>


<p>zcard(name)</p>
<p># 获取name对应的有序集合元素的数量</p>

<p>zcount(name, min, max)</p>
<p># 获取name对应的有序集合中分数 在 [min,max] 之间的个数</p>


<p>zincrby(name, value, amount)</p>
<p># 自增name对应的有序集合的 name 对应的分数</p>

<p>r.zrange( name, start, end, desc=False, withscores=False, score_cast_func=float)</p>
<p><code># 按照索引范围获取name对应的有序集合的元素</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># start，有序集合索引起始位置（非分数）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># end，有序集合索引结束位置（非分数）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># desc，排序规则，默认按照分数从小到大排序</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># withscores，是否获取元素的分数，默认只获取元素的值</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># score_cast_func，对分数进行数据转换的函数</code></p>

<p><code># 更多：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 从大到小排序</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># zrevrange(name, start, end, withscores=False, score_cast_func=float)</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 按照分数范围获取name对应的有序集合的元素</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># zrangebyscore(name, min, max, start=None, num=None, withscores=False, score_cast_func=float)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 从大到小排序</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># zrevrangebyscore(name, max, min, start=None, num=None, withscores=False, score_cast_func=float)</code></p>


<p>zrank(name, value)</p>
<p><code># 获取某个值在 name对应的有序集合中的排行（从 0 开始）</code></p>

<p><code># 更多：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># zrevrank(name, value)，从大到小排序</code></p>


<p>zrangebylex(name, min, max, start=None, num=None)</p>
<p><code># 当有序集合的所有成员都具有相同的分值时，有序集合的元素会根据成员的 值 （lexicographical ordering）来进行排序，而这个命令则可以返回给定的有序集合键 key 中， 元素的值介于 min 和 max 之间的成员</code></p>
<p><code># 对集合中的每个成员进行逐个字节的对比（byte-by-byte compare）， 并按照从低到高的顺序， 返回排序后的集合成员。 如果两个字符串有一部分内容是相同的话， 那么命令会认为较长的字符串比较短的字符串要大</code></p>

<p><code># 参数：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># name，redis的name</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># min，左区间（值）。 + 表示正无限； - 表示负无限； ( 表示开区间； [ 则表示闭区间</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># min，右区间（值）</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># start，对结果进行分片处理，索引位置</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># num，对结果进行分片处理，索引后面的num个元素</code></p>

<p><code># 如：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># ZADD myzset 0 aa 0 ba 0 ca 0 da 0 ea 0 fa 0 ga</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># r.zrangebylex(‘myzset‘, "-", "[ca") 结果为：[‘aa‘, ‘ba‘, ‘ca‘]</code></p>

<p><code># 更多：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># 从大到小排序</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># zrevrangebylex(name, max, min, start=None, num=None)</code></p>


<p>zrem(name, values)</p>
<p><code># 删除name对应的有序集合中值是values的成员</code></p>

<p><code># 如：zrem(‘zz‘, [‘s1‘, ‘s2‘])</code></p>


<p>zremrangebyrank(name, min, max)</p>
<p># 根据排行范围删除</p>

<p>zremrangebyscore(name, min, max)</p>
<p># 根据分数范围删除</p>

<p>zremrangebylex(name, min, max)</p>
<p># 根据值返回删除</p>

<p>zscore(name, value)</p>
<p># 获取name对应有序集合中 value 对应的分数</p>

<p>zinterstore(dest, keys, aggregate=None)</p>
<p><code># 获取两个有序集合的交集，如果遇到相同值不同分数，则按照aggregate进行操作</code></p>
<p><code># aggregate的值为:&nbsp; SUM&nbsp; MIN&nbsp; MAX</code></p>


<p>zunionstore(dest, keys, aggregate=None)</p>
<p><code># 获取两个有序集合的并集，如果遇到相同值不同分数，则按照aggregate进行操作</code></p>
<p><code># aggregate的值为:&nbsp; SUM&nbsp; MIN&nbsp; MAX</code></p>


<p>zscan(name, cursor=0, match=None, count=None, score_cast_func=float)<br />zscan_iter(name, match=None, count=None,score_cast_func=float)</p>
<p># 同字符串相似，相较于字符串新增score_cast_func，用来对分数进行操作</p>


<p>其他常用操作</p>
<p>delete(*names)</p>
<p># 根据删除redis中的任意数据类型</p>


<p>exists(name)</p>
<p># 检测redis的name是否存在</p>


<p>keys(pattern=‘*‘)</p>
<p><code># 根据模型获取redis的name</code></p>

<p><code># 更多：</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># KEYS * 匹配数据库中所有 key 。</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># KEYS h?llo 匹配 hello ， hallo 和 hxllo 等。</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># KEYS h*llo 匹配 hllo 和 heeeeello 等。</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code># KEYS h[ae]llo 匹配 hello 和 hallo ，但不匹配 hillo</code></p>

<p>expire(name ,time)</p>
<p># 为某个redis的某个name设置超时时间</p>

<p>rename(src, dst)</p>
<p># 对redis的name重命名为</p>


<p>move(name, db))</p>
<p># 将redis的某个值移动到指定的db下</p>


<p>randomkey()</p>
<p># 随机获取一个redis的name（不删除）</p>


<p>type(name)</p>
<p># 获取name对应值的类型</p>


<p>scan(cursor=0, match=None, count=None)<br />scan_iter(match=None, count=None)</p>
<p># 同字符串操作，用于增量迭代获取key</p>


<p>4、管道</p>
<p>redis-py默认在执行每次请求都会创建（连接池申请连接）和断开（归还连接池）一次连接操作，如果想要在一次请求中指定多个命令，则可以使用pipline实现一次请求指定多个命令，并且默认情况下一次pipline 是原子性操作。</p>
<pre>import redis

pool = redis.ConnectionPool(host=‘10.211.55.5‘, port=6379,max_connections=50)

r = redis.Redis(connection_pool=pool)

# pipe = r.pipeline(transaction=False)
pipe = r.pipeline(transaction=True)

r.set(‘name‘, ‘alex‘)     #执行1
r.set(‘role‘, ‘sb‘)           #执行2  // 当执行1完成后，执行2失败，那么执行1这个操作将回滚，相当于没有执行

pipe.execute()
</pre>
<p>5、发布订阅</p>
<p>发布订阅就跟听众收到广播电台一样，可以有多个发布方，多个频道，多个听众，前面的电台，跟频道一般是固定的，所以发布的话跟听众多少无关，只要听众订阅某个频道，就能收到该频道上发布的所有内容</p>



<p>demo</p>
<pre>import redis

class RedisHelper:

    def __init__(self):
        self.__conn = redis.Redis(host=‘10.211.55.5‘)
        self.chan_sub = ‘fm104.5‘
        self.chan_pub = ‘fm104.5‘

    def public(self, msg):
        self.__conn.publish(self.chan_pub, msg)
        return True

    def subscribe(self):
        pub = self.__conn.pubsub()
        pub.subscribe(self.chan_sub)
        pub.parse_response()
        return pub
</pre>
<p>订阅者</p>

<pre>from my_demo import RedisHelper

obj = RedisHelper()
redis_sub = obj.subscribe()

while True:
    msg= redis_sub.parse_response()
    print msg
</pre>
<p>发布者</p>
<pre>from my_demo import RedisHelper

obj = RedisHelper()
obj.public(‘hello‘)
</pre>

<h3>RabbitMQ</h3></p>
<p>RabbitMQ是一个在AMQP基础上完整的，可复用的企业消息系统。他遵循Mozilla Public License开源协议。</p>
<p>MQ全称为Message Queue,&nbsp;<a href="http://baike.baidu.com/view/262473.htm" rel="external nofollow noreferrer">消息队列</a>（MQ）是一种应用程序对应用程序的通信方法。应用程序通过读写出入队列的消息（针对应用程序的数据）来通信，而无需专用连接来链接它们。消 息传递指的是程序之间通过在消息中发送数据进行通信，而不是通过直接调用彼此来通信，直接调用通常是用于诸如<a href="http://baike.baidu.com/view/431455.htm" rel="external nofollow noreferrer">远程过程调用</a>的技术。排队指的是应用程序通过 队列来通信。队列的使用除去了接收和发送应用程序同时执行的要求。</p>
<p>RabbitMQ安装(CENTOS6)</p>
<p>wget -O /etc/yum.repos.d/CentOS-Base.repo http://mirrors.aliyun.com/repo/Centos-6.repo</p>
<p>wget -O /etc/yum.repos.d/epel.repo http://mirrors.aliyun.com/repo/epel-6.repo</p>
<p>yum -y install rabbitmq-server</p>


<p>启动：/etc/init.d/rabbitmq-server start</p>
<p>停止：/etc/init.d/rabbitmq-server stop</p>

<p>安装API</p>

<p>pip3 install pika</p>
<p>or</p>
<p>easy_install pika</p>
<p>or</p>
<p>source code</p>

<p>https://pypi.python.org/pypi/pika</p>


<p>使用API操作RabbitMQ</p>
<p>基于Queue实现生产者消费者模型</p>

<pre>#!/usr/bin/env python
# -*- coding:utf-8 -*-
import Queue
import threading

message = Queue.Queue(10)

def producer(i):
    while True:
        message.put(i)

def consumer(i):
    while True:
        msg = message.get()

for i in range(12):
    t = threading.Thread(target=producer, args=(i,))
    t.start()

for i in range(10):
    t = threading.Thread(target=consumer, args=(i,))
    t.start()
</pre>
<p>对于RabbitMQ来说，生产和消费不再针对内存里的一个Queue对象，而是某台服务器上的RabbitMQ Server实现的消息队列。</p>
<pre>import pika

# ######################### 生产者 #########################

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.queue_declare(queue=‘hello‘)

channel.basic_publish(exchange=‘‘,
                      routing_key=‘hello‘,
                      body=‘Hello World!‘)
print(" [x] Sent ‘Hello World!‘")
connection.close()
</pre>
<pre>import pika

# ########################## 消费者 ##########################

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.queue_declare(queue=‘hello‘)

def callback(ch, method, properties, body):
    print(" [x] Received %r" % body)

channel.basic_consume(callback,
                      queue=‘hello‘,
                      no_ack=True)

print(‘ [*] Waiting for messages. To exit press CTRL+C‘)
channel.start_consuming()
</pre>
<p>1、acknowledgment 消息不丢失</p>
<p>no-ack ＝ False，如果消费者遇到情况(its channel is closed, connection is closed, or TCP connection is lost)挂掉了，那么，RabbitMQ会重新将该任务添加到队列中。</p>
<pre>import pika

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘10.211.55.4‘))
channel = connection.channel()

channel.queue_declare(queue=‘hello‘)

def callback(ch, method, properties, body):
    print(" [x] Received %r" % body)
    import time
    time.sleep(10)
    print ‘ok‘
    ch.basic_ack(delivery_tag = method.delivery_tag)

channel.basic_consume(callback,
                      queue=‘hello‘,
                      no_ack=False)

print(‘ [*] Waiting for messages. To exit press CTRL+C‘)
channel.start_consuming()
</pre>
<p>2、durable &nbsp; 消息不丢失</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika

connection = pika.BlockingConnection(pika.ConnectionParameters(host=‘10.211.55.4‘))
channel = connection.channel()

# make message persistent
channel.queue_declare(queue=‘hello‘, durable=True)

channel.basic_publish(exchange=‘‘,
                      routing_key=‘hello‘,
                      body=‘Hello World!‘,
                      properties=pika.BasicProperties(
                          delivery_mode=2, # make message persistent
                      ))
print(" [x] Sent ‘Hello World!‘")
connection.close()</pre>
<p>生产者</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika

connection = pika.BlockingConnection(pika.ConnectionParameters(host=‘10.211.55.4‘))
channel = connection.channel()

# make message persistent
channel.queue_declare(queue=‘hello‘, durable=True)

def callback(ch, method, properties, body):
    print(" [x] Received %r" % body)
    import time
    time.sleep(10)
    print ‘ok‘
    ch.basic_ack(delivery_tag = method.delivery_tag)

channel.basic_consume(callback,
                      queue=‘hello‘,
                      no_ack=False)

print(‘ [*] Waiting for messages. To exit press CTRL+C‘)
channel.start_consuming()</pre>
<p>消费者</p>
<p>3、消息获取顺序</p>
<p>默认消息队列里的数据是按照顺序被消费者拿走，例如：消费者1 去队列中获取 奇数 序列的任务，消费者1去队列中获取 偶数 序列的任务。</p>
<p>channel.basic_qos(prefetch_count=1) 表示谁来谁取，不再按照奇偶数排列</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika

connection = pika.BlockingConnection(pika.ConnectionParameters(host=‘10.211.55.4‘))
channel = connection.channel()

# make message persistent
channel.queue_declare(queue=‘hello‘)

def callback(ch, method, properties, body):
    print(" [x] Received %r" % body)
    import time
    time.sleep(10)
    print ‘ok‘
    ch.basic_ack(delivery_tag = method.delivery_tag)

channel.basic_qos(prefetch_count=1)

channel.basic_consume(callback,
                      queue=‘hello‘,
                      no_ack=False)

print(‘ [*] Waiting for messages. To exit press CTRL+C‘)
channel.start_consuming()</pre>
<p>消费者</p>
<p>4、发布订阅</p>
<p><img src="//images2015.cnblogs.com/blog/959078/201607/959078-20160730094709528-97569067.png" /></p>
<p>发布订阅和简单的消息队列区别在于，发布订阅会将消息发送给所有的订阅者，而消息队列中的数据被消费一次便消失。所以，RabbitMQ实现发布和订阅时，会为每一个订阅者创建一个队列，而发布者发布消息时，会将消息放置在所有相关队列中。</p>
<p>exchange type = fanout</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika
import sys

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.exchange_declare(exchange=‘logs‘,
                         type=‘fanout‘)

message = ‘ ‘.join(sys.argv[1:]) or "info: Hello World!"
channel.basic_publish(exchange=‘logs‘,
                      routing_key=‘‘,
                      body=message)
print(" [x] Sent %r" % message)
connection.close()</pre>
<p>发布者</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.exchange_declare(exchange=‘logs‘,
                         type=‘fanout‘)

result = channel.queue_declare(exclusive=True)
queue_name = result.method.queue

channel.queue_bind(exchange=‘logs‘,
                   queue=queue_name)

print(‘ [*] Waiting for logs. To exit press CTRL+C‘)

def callback(ch, method, properties, body):
    print(" [x] %r" % body)

channel.basic_consume(callback,
                      queue=queue_name,
                      no_ack=True)

channel.start_consuming()</pre>
<p>订阅者</p>


<p>5、关键字发送</p>

<p><img src="//images2015.cnblogs.com/blog/959078/201607/959078-20160730094906606-1929625052.png" /></p>



<p>exchange type = direct</p>
<p>之前事例，发送消息时明确指定某个队列并向其中发送消息，RabbitMQ还支持根据关键字发送，即：队列绑定关键字，发送者将数据根据关键字发送到消息exchange，exchange根据 关键字 判定应该将数据发送至指定队列。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika
import sys

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.exchange_declare(exchange=‘direct_logs‘,
                         type=‘direct‘)

result = channel.queue_declare(exclusive=True)
queue_name = result.method.queue

severities = sys.argv[1:]
if not severities:
    sys.stderr.write("Usage: %s [info] [warning] [error]\n" % sys.argv[0])
    sys.exit(1)

for severity in severities:
    channel.queue_bind(exchange=‘direct_logs‘,
                       queue=queue_name,
                       routing_key=severity)

print(‘ [*] Waiting for logs. To exit press CTRL+C‘)

def callback(ch, method, properties, body):
    print(" [x] %r:%r" % (method.routing_key, body))

channel.basic_consume(callback,
                      queue=queue_name,
                      no_ack=True)

channel.start_consuming()</pre>
<p>消费者</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika
import sys

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.exchange_declare(exchange=‘direct_logs‘,
                         type=‘direct‘)

severity = sys.argv[1] if len(sys.argv) &gt; 1 else ‘info‘
message = ‘ ‘.join(sys.argv[2:]) or ‘Hello World!‘
channel.basic_publish(exchange=‘direct_logs‘,
                      routing_key=severity,
                      body=message)
print(" [x] Sent %r:%r" % (severity, message))
connection.close()</pre>
<p>生产者</p>
<p>6、模糊匹配</p>
<p><img src="//images2015.cnblogs.com/blog/959078/201607/959078-20160730095046997-1263663827.png" /></p>
<p>exchange type = topic</p>
<p>在topic类型下，可以让队列绑定几个模糊的关键字，之后发送者将数据发送到exchange，exchange将传入&rdquo;路由值&ldquo;和 &rdquo;关键字&ldquo;进行匹配，匹配成功，则将数据发送到指定队列。</p>
<ul>
<li># 表示可以匹配 0 个 或 多个 单词</li>
<li>* &nbsp;表示只能匹配 一个 单词</li>
</ul>
<p><code>发送者路由值&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 队列中</code></p>
<p><code>mage.python&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; old.</code><code>*</code>&nbsp;&nbsp;<code>-</code><code>-</code>&nbsp;<code>不匹配</code></p>
<p><code>mage.python&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; old.</code><code>#&nbsp; -- 匹配</code></p>


<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika
import sys

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.exchange_declare(exchange=‘topic_logs‘,
                         type=‘topic‘)

result = channel.queue_declare(exclusive=True)
queue_name = result.method.queue

binding_keys = sys.argv[1:]
if not binding_keys:
    sys.stderr.write("Usage: %s [binding_key]...\n" % sys.argv[0])
    sys.exit(1)

for binding_key in binding_keys:
    channel.queue_bind(exchange=‘topic_logs‘,
                       queue=queue_name,
                       routing_key=binding_key)

print(‘ [*] Waiting for logs. To exit press CTRL+C‘)

def callback(ch, method, properties, body):
    print(" [x] %r:%r" % (method.routing_key, body))

channel.basic_consume(callback,
                      queue=queue_name,
                      no_ack=True)

channel.start_consuming()</pre>
<p>消费者</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>import pika
import sys

connection = pika.BlockingConnection(pika.ConnectionParameters(
        host=‘localhost‘))
channel = connection.channel()

channel.exchange_declare(exchange=‘topic_logs‘,
                         type=‘topic‘)

routing_key = sys.argv[1] if len(sys.argv) &gt; 1 else ‘anonymous.info‘
message = ‘ ‘.join(sys.argv[2:]) or ‘Hello World!‘
channel.basic_publish(exchange=‘topic_logs‘,
                      routing_key=routing_key,
                      body=message)
print(" [x] Sent %r:%r" % (routing_key, message))
connection.close()</pre>
<p>生产者</p>
<h3>SQLAlchemy</h3>
<p>SQLAlchemy是<a href="http://baike.baidu.com/subview/21087/21087.htm" rel="external nofollow noreferrer">Python</a>编程语言下的一款ORM框架，该框架建立在数据库API之上，使用关系对象映射进行数据库操作，简言之便是：将对象转换成SQL，然后使用数据API执行SQL并获取执行结果。</p>
<p><img src="//images2015.cnblogs.com/blog/959078/201607/959078-20160730095348513-19588177.png" /></p>
<p>Dialect用于和数据API进行交流，根据配置文件的不同调用不同的数据库API，从而实现对数据库的操作，如：</p>
<pre>MySQL-Python
    mysql+mysqldb://&lt;user&gt;:&lt;password&gt;@&lt;host&gt;[:&lt;port&gt;]/&lt;dbname&gt;

pymysql
    mysql+pymysql://&lt;username&gt;:&lt;password&gt;@&lt;host&gt;/&lt;dbname&gt;[?&lt;options&gt;]

MySQL-Connector
    mysql+mysqlconnector://&lt;user&gt;:&lt;password&gt;@&lt;host&gt;[:&lt;port&gt;]/&lt;dbname&gt;

cx_Oracle
    oracle+cx_oracle://user:[email&#160;protected]:port/dbname[?key=value&amp;key=value...]

更多详见：http://docs.sqlalchemy.org/en/latest/dialects/index.html
</pre>
<p>步骤一：</p>
<p>使用 Engine/ConnectionPooling/Dialect 进行数据库操作，Engine使用ConnectionPooling连接数据库，然后再通过Dialect执行SQL语句。</p>
<pre>from sqlalchemy import create_engine

engine = create_engine("mysql+mysqldb://root:[email&#160;protected]:3306/s11", max_overflow=5)

engine.execute(
    "INSERT INTO ts_test (a, b) VALUES (‘2‘, ‘v1‘)"
)

engine.execute(
     "INSERT INTO ts_test (a, b) VALUES (%s, %s)",
    ((777, "v1"),(888, "v1"),)
)
engine.execute(
    "INSERT INTO ts_test (a, b) VALUES (%(id)s, %(name)s)",
    id=999, name="v1"
)

result = engine.execute(‘select * from ts_test‘)
result.fetchall()
</pre>
<pre>from sqlalchemy import create_engine

engine = create_engine("mysql+mysqldb://root:[email&#160;protected]:3306/s11", max_overflow=5)

# 事务操作
with engine.begin() as conn:
    conn.execute("insert into table (x, y, z) values (1, 2, 3)")
    conn.execute("my_special_procedure(5)")

conn = engine.connect()
# 事务操作
with conn.begin():
       conn.execute("some statement", {‘x‘:5, ‘y‘:10})</pre>
<p><em>注：查看数据库连接：show status like ‘Threads%‘;</em></p>
<p>上面的操作没什么用，代码的可用性依旧不高</p>
<p>步骤二：</p>
<p>使用 Schema Type/SQL Expression Language/Engine/ConnectionPooling/Dialect 进行数据库操作。Engine使用Schema Type创建一个特定的结构对象，之后通过SQL Expression Language将该对象转换成SQL语句，然后通过&nbsp;ConnectionPooling 连接数据库，再然后通过&nbsp;Dialect 执行SQL，并获取结果。</p>
<pre>from sqlalchemy import create_engine, Table, Column, Integer, String, MetaData, ForeignKey

metadata = MetaData()

user = Table(‘user‘, metadata,
    Column(‘id‘, Integer, primary_key=True),
    Column(‘name‘, String(20)),
)

color = Table(‘color‘, metadata,
    Column(‘id‘, Integer, primary_key=True),
    Column(‘name‘, String(20)),
)
engine = create_engine("mysql+mysqldb://root:[email&#160;protected]:3306/s11", max_overflow=5)

metadata.create_all(engine)
# metadata.clear()
# metadata.remove()</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>from sqlalchemy import create_engine, Table, Column, Integer, String, MetaData, ForeignKey

metadata = MetaData()

user = Table(‘user‘, metadata,
    Column(‘id‘, Integer, primary_key=True),
    Column(‘name‘, String(20)),
)

color = Table(‘color‘, metadata,
    Column(‘id‘, Integer, primary_key=True),
    Column(‘name‘, String(20)),
)
engine = create_engine("mysql+mysqldb://root:[email&#160;protected]:3306/s11", max_overflow=5)

conn = engine.connect()

# 创建SQL语句，INSERT INTO "user" (id, name) VALUES (:id, :name)
conn.execute(user.insert(),{‘id‘:7,‘name‘:‘seven‘})
conn.close()

# sql = user.insert().values(id=123, name=‘wu‘)
# conn.execute(sql)
# conn.close()

# sql = user.delete().where(user.c.id &gt; 1)

# sql = user.update().values(fullname=user.c.name)
# sql = user.update().where(user.c.name == ‘jack‘).values(name=‘ed‘)

# sql = select([user, ])
# sql = select([user.c.id, ])
# sql = select([user.c.name, color.c.name]).where(user.c.id==color.c.id)
# sql = select([user.c.name]).order_by(user.c.name)
# sql = select([user]).group_by(user.c.name)

# result = conn.execute(sql)
# print result.fetchall()
# conn.close()</pre>
<p>增删改查</p>
<p>更多内容详见：</p>
<p>http://www.jianshu.com/p/e6bba189fcbd</p>
<p>http://docs.sqlalchemy.org/en/latest/core/expression_api.html</p>
<p>注：SQLAlchemy无法修改表结构，如果需要可以使用SQLAlchemy开发者开源的另外一个软件Alembic来完成。</p>
<p>步骤三：</p>
<p>使用 ORM/Schema Type/SQL Expression Language/Engine/ConnectionPooling/Dialect 所有组件对数据进行操作。根据类创建对象，对象转换成SQL，执行SQL。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy import Column, Integer, String
from sqlalchemy.orm import sessionmaker
from sqlalchemy import create_engine

engine = create_engine("mysql+mysqldb://root:[email&#160;protected]:3306/s11", max_overflow=5)

Base = declarative_base()

class User(Base):
    __tablename__ = ‘users‘
    id = Column(Integer, primary_key=True)
    name = Column(String(50))

# 寻找Base的所有子类，按照子类的结构在数据库中生成对应的数据表信息
# Base.metadata.create_all(engine)

Session = sessionmaker(bind=engine)
session = Session()

# ########## 增 ##########
# u = User(id=2, name=‘sb‘)
# session.add(u)
# session.add_all([
#     User(id=3, name=‘sb‘),
#     User(id=4, name=‘sb‘)
# ])
# session.commit()

# ########## 删除 ##########
# session.query(User).filter(User.id &gt; 2).delete()
# session.commit()

# ########## 修改 ##########
# session.query(User).filter(User.id &gt; 2).update({‘cluster_id‘ : 0})
# session.commit()
# ########## 查 ##########
# ret = session.query(User).filter_by(name=‘sb‘).first()

# ret = session.query(User).filter_by(name=‘sb‘).all()
# print ret

# ret = session.query(User).filter(User.name.in_([‘sb‘,‘bb‘])).all()
# print ret

# ret = session.query(User.name.label(‘name_label‘)).all()
# print ret,type(ret)

# ret = session.query(User).order_by(User.id).all()
# print ret

# ret = session.query(User).order_by(User.id)[1:3]
# print ret
# session.commit()</pre>
<p></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-12 12:13:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Python操作 Memcache、Redis、RabbitMQ、SQLAlchemy的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmwmNB3.html" rel="bookmark">python操作memcache&sol;redis&sol;rabbitmq</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据库操作: - 数据库 - 表 a. 单表 b. 一对多 用户类型: 1 超级用户 2 普通用户 3 二笔用户 用户: 方式器 3(设置数字,约束=外键(表,列)) 刘浩 6 何磊 3 何磊 3 c. 多对多 主机:主机名 .... 1 c1.com 2 c1.com 3 c1.com 4 c1.com 用户表:用户名 .... 1 严选育 2 卢饶 3 泥泞 4 利用三 装B: 用户 主机 时间 4 1 83 4 2 83 4 1 93 4 2 93 3 2 93 相亲: 1 严选育 2 卢			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0le7XN3.html" rel="bookmark">Python之路【第十篇】Python操作Memcache、Redis、RabbitMQ、SQLAlchemy、</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Memcached Memcached 是一个高性能的分布式内存对象缓存系统,用于动态Web应用以减轻数据库负载.它通过在内存中缓存数据和对象来减少读取数据库的次数,从而提高动态.数据库驱动网站的速度.Memcached基于一个存储键/值对的hashmap.其守护进程(daemon )是用C写的,但是客户端可以用任何语言来编写,并通过memcached协议与守护进程通信. 1.Memcached安装配置 #安装倚赖包 yum install libevent-devel #安装软件 yum -y			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r2V2q3.html" rel="bookmark">Python操作 Memcache、Redis、RabbitMQ</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Memcached Memcached 是一个高性能的分布式内存对象缓存系统,用于动态Web应用以减轻数据库负载.它通过在内存中缓存数据和对象来减少读取数据库的次数,从而提高动态.数据库驱动网站的速度.Memcached基于一个存储键/值对的hashmap.其守护进程(daemon )是用C写的,但是客户端可以用任何语言来编写,并通过memcached协议与守护进程通信. memcached安装: memcached -d -m 10 -u root -l 192.168.132.130 -p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDlYe7M.html" rel="bookmark">Day11 - Python操作memcache、redis缓存、rabbitMQ队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本周课前必备: 1. Memcached 2. Python操作Memcached模块: https://pypi.python.org/pypi/python-memcached 3. Redis 4. Python操作Redis模块:pip3 install redis 5. RabbitMQ 6. Python操作RabbitMQ模块:pip install pika http://www.cnblogs.com/wupeiqi/articles/5132791.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lWdJoM.html" rel="bookmark">Python操作Memcache</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Memcached Memcached 是一个高性能的分布式内存对象缓存系统,用于动态Web应用以减轻数据库负载.它通过在内存中缓存数据和对象来减少读取数据库的次数,从而提高动态.数据库驱动网站的速度.Memcached基于一个存储键/值对的hashmap.其守护进程(daemon )是用C写的,但是客户端可以用任何语言来编写,并通过memcached协议与守护进程通信. Memcached安装和基本使用 Memcached安装: 1 wget http://memcached.org/late			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NzbXo4.html" rel="bookmark">python操作mysql（pymysql &plus; sqlalchemy）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				pymysql pymsql是Python中操作MySQL的模块,其使用方法和MySQLdb几乎相同. 下载安装 pip3 install pymysql 使用操作 1.执行sql #!/usr/bin/env python # -*- coding:utf-8 -*- import pymysql # 创建连接 conn = pymysql.connect(host='127.0.0.1', port=3306, user='root', passwd='123', db='t1') # 创建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AjmozM.html" rel="bookmark">使用Python操作memcache</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Python连接memcached的库有很多,处于简单以及高效的原则,最终选择了pymemcache, 优点 完全实现了memcached text协议 对于send/recv操作可以配置timeout 支持&quot;noreply&quot;特性,该可行可以先出的提高写的速度 使序列化/反序列化更简单 可以将网络异常,memecached错误当成是缓存丢失 安装pymemcachepip install pymemcache 使用pymemcache 基本操作 from pymemcache.clie			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wBBrl0.html" rel="bookmark">Python操作MySQL -即pymysql&sol;SQLAlchemy用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节介绍Python对于MySQL的一些操作用法 模块:pymysql(等同于MySQLdb) 说明:pymysql与MySQLdb模块的使用基本相同,学会pymysql,使用MySQLdb也就不是问题 安装API pip install PyMySQL 操作 #!/usr/bin/env python # -*- coding: utf-8 -*- # auth : pangguoping import pymysql # 创建连接 conn = pymysql.connect(host='1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/415GBq4.html" rel="bookmark">192&period;168&period;62&period;124python运维开发&lpar;十一&rpar;----python操作缓存memcache、redis</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内容目录: 缓存 memcache redis memcache Memcached 是一个高性能的分布式内存对象缓存系统,用于动态Web应用以减轻数据库负载.它通过在内存中缓存数据和对象来减少读取数据库的次数,从而提高动态.数据库驱动网站的速度.Memcached基于一个存储键/值对的hashmap.其守护进程(daemon )是用C写的,但是客户端可以用任何语言来编写,并通过memcached协议与守护进程通信. Memcached安装配置 #安装依赖包 yum install libeve			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OmbOrM.html" rel="bookmark" class="title">创建触发器</a>
					<div>
						CREATE TRIGGER    [dbo].[table1_column1]  ON [dbo].table1 for INSERT, UPDATE --after INSERT, UPDATE  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZYppl0.html" rel="bookmark" class="title">JavaScript权威指南 - 函数</a>
					<div>
						函数本身就是一段JavaScript代码,定义一次但可能被调用任意次.如果函数挂载在一个对象上,作为对象的一个属性,通常这种函数被称作对象的方法.用于初始化一个新创建的对象的函数被称作构造函数. 相对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Z1AlM.html" rel="bookmark" class="title">《oracle每天一练》Oracle之物化视图</a>
					<div>
						相关帖子思考和跟踪 本文转自Ronger 物化视图是一种特殊的物理表,“物化”(Materialized)视图是相对普通视图而言的.普通视图是虚拟表,应用的局限性大,任何对视图的查询,Oracle都实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rExO90.html" rel="bookmark" class="title">如何用css实现类似简书的纵向导航&sol;竖排导航</a>
					<div>
						作为一个专注阅读的网站,它的导航也一定是全局的,固定的,也是简洁的.事实上几家阅读网站豆瓣阅读,多看,简书都是这样做的,刚好实现起来也不算复杂,以下是我想到的实现方法. 首先是html的结构: 1 & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41897o3.html" rel="bookmark" class="title">Maven Java EE Configuration Problem问题</a>
					<div>
						问题:Cannot change version of project facet Dynamic Web Module to 2.4. 解决方案: 找到该项目目录.settings下的文件org.e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5rdo3.html" rel="bookmark" class="title">Android Studio下SlidingMenu的导入与基础使用</a>
					<div>
						一.关于这个控件,其实我们现在很多app都在用,最简单的,你打开QQ,当看资料卡的时候,首先要侧拉一下,那个就是SlidingMenu 这几天查了很多资料,各种方法都试了,但是一直都没有成功,最后在一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myl1Bp4.html" rel="bookmark" class="title">Java 5 特性 Instrumentation 实践</a>
					<div>
						简介 不使用instrumentation 来测量函数运行时间的传统方法是:在函数调用之前记录当前系统时间,在函数调用完成之后再次记录当前系统时间(为了简化描述,本文不考虑虚拟机进程映射到本地操作系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bOrPw3.html" rel="bookmark" class="title">对 set 的遍历</a>
					<div>
						对 set 的遍历 1.迭代遍历: Set&lt;String&gt; set = new HashSet&lt;String&gt;(); Iterator&lt;String&gt; it = s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORqAr0.html" rel="bookmark" class="title">MvcPager&period;js在特定业务场景下的问题解决</a>
					<div>
						用到了MvcPager.js,在一个常见的场景中出现了不能POST表单数据的问题,场景描述如下: 日期:2012-12-12 编号:*****                              ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wENg0.html" rel="bookmark" class="title">swift3&period;0 coredata 的使用</a>
					<div>
						//swift3.0在语法上有很大的改变,以简单的增删改查为例,如下: //User类如下: import Foundation import CoreData extension User { @n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41omKo0.html" rel="bookmark" class="title">hdoj 5399 Tpp simple</a>
					<div>
						WA了一下午.... 1WA:T了,因为阶乘没打表所以时间超了.. 2WA,3WA:runtime error,检查的value数组开小了,应该是MAXN.. 4WA.5WA.6WA:改了改对cnt的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jyo2A3.html" rel="bookmark" class="title">devexpress显示缓冲滚动条与实现类似QQ消息推送效果</a>
					<div>
						1.一般在项目中处理大数据,或者查询大量数据时,耗时会很长,这个时候缓冲条是必不可少的.这里展示一个devexpress不错的缓冲条,如图所示: 使用到了控件splashScreenManager,运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0doKB6M.html" rel="bookmark" class="title">开始微信小程序&lpar;1&rpar;</a>
					<div>
						IDE下载 微信web开发者工具 需要微信扫一扫登录. 如果没有公众号可以选择无appid 直接进入,如果有可以填写appid,可以尝试更多功能. 基本操作 Ctrl+S:保存文件 Ctrl+[, C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqRmw4.html" rel="bookmark" class="title">VS下控制台运行保持（不要一闪而过）</a>
					<div>
						以前上课的时候是用VC++6.0来学习编程的,编完打印出来的东西就直接显示在控制台上.而在Visual Studio下会出现控制台一闪而过的情况.这个问题其实是很好解决的,方法有多种,下面列举两种常用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnL6G0.html" rel="bookmark" class="title">android camera&lpar;一&rpar;：camera模组CMM介绍【转】</a>
					<div>
						转自:http://blog.csdn.net/xubin341719/article/details/7723725 版权声明:本文为博主原创文章,未经博主允许不得转载. 关键词:android   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47ea2R0.html" rel="bookmark" class="title">定义Map常量，List常量</a>
					<div>
						一般的方式的使用静态代码块.比如: public final static Map map = new HashMap(); static { map.put(&quot;key1&quot;, &q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41Gqrk0.html" rel="bookmark" class="title">InnoDB &comma;  MyISAM &colon;MySQL 5&period;7 Supported Storage Engines</a>
					<div>
						http://dev.mysql.com/doc/refman/5.7/en/storage-engines.html https://en.wikipedia.org/wiki/ACID https ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgNNR3.html" rel="bookmark" class="title">C&num;Graphics画图</a>
					<div>
						public Form1() { InitializeComponent(); } private void button1_Click(object sender, EventArgs e) { G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdlR60.html" rel="bookmark" class="title">Deep Learning Face Representation from Predicting 10&comma;000 Classes论文笔记</a>
					<div>
						Deep Learning Face Representation from Predicting 10,000 Classes论文笔记(2015.03.24) 一.基本思路 作者利用卷积神经网络(C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQqqB3.html" rel="bookmark" class="title">求两点之间最短路径-Dijkstra算法</a>
					<div>
						 Dijkstra算法 1.定义概览 Dijkstra(迪杰斯特拉)算法是典型的单源最短路径算法,用于计算一个节点到其他所有节点的最短路径.主要特点是以起始点为中心向外层层扩展,直到扩展到终点为止.D ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
